#!/bin/bash

# note sorting error might occur (ToDo)

# OUT=`./cegartix -h 2>&1 | grep "Version"`
# if [ "$OUT" == "" ];
# then
#   echo "Error: no help message"
# fi
# 
# OUT=`./cegartix -u 2>&1| grep "Unknown flag"`
# if [ "$OUT" == "" ];
# then
#   echo "Error: unknown flag not recognized"
# fi

echo "To run older tests (with higher running time; 1-3 mins) run "$0" all"

echo "Starting tests ..."

echo "Running cegartix with some test AFs"

RESULT=`./cegartix -semantics=grd -mode=enum tests/self-attack.apx 2>/dev/null`
if [ "$RESULT" != "[[]]" ];
then
  echo error expected empty grounded
fi

RESULT=`./cegartix -semantics=stable -mode=enum tests/self-attack.apx 2>/dev/null`
if [ "$RESULT" != "[]" ];
then
  echo error expected empty set of stable 
fi

RESULT=`./cegartix -semantics=semi -mode=enum tests/self-attack.apx 2>/dev/null`
if [ "$RESULT" != "[[]]" ];
then
  echo error expected set with empty semi
fi

RESULT=`./cegartix -semantics=stage -mode=enum tests/self-attack.apx 2>/dev/null`
if [ "$RESULT" != "[[]]" ];
then
  echo error expected set with empty stage
fi

RESULT=`./cegartix -semantics=pref -mode=cred tests/cred-vs-skept.apx -argument=a 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error pref cred
fi

RESULT=`./cegartix -semantics=pref -mode=skept tests/cred-vs-skept.apx -argument=a 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error pref skept
fi

RESULT=`./cegartix -semantics=pref -mode=cred tests/cred-vs-skept.apx -argument=d 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error pref cred 2
fi

RESULT=`./cegartix -semantics=pref -mode=skept tests/cred-vs-skept.apx -argument=d 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error pref skept 2
fi

RESULT=`./cegartix -semantics=ideal -mode=enum tests/cred-vs-skept.apx  2>/dev/null`
if [ "$RESULT" != "[[]]" ];
then
  echo error ideal
fi

RESULT=`./cegartix -semantics=pref -mode=enum tests/cred-vs-skept.apx  2>/dev/null`
if [ "$RESULT" != "[[b,d],[a,d]]" ];
then
  echo error pref enum
fi

RESULT=`./cegartix -semantics=com -mode=enum tests/cred-vs-skept.apx  2>/dev/null`
if [ "$RESULT" != "[[],[b,d],[a,d]]" ];
then
  echo error complete enum
fi

RESULT=`./cegartix -semantics=adm -mode=enum tests/cred-vs-skept.apx  2>/dev/null`
if [ "$RESULT" != "[[],[a,d],[b,d],[b],[a]]" ];
then
  echo error adm enum
fi

echo "Performing simple input-output tests for ICCMA'17"


# preferred
RESULT=`./cegartix-run.sh -p DS-PR -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DS-PR
fi

RESULT=`./cegartix-run.sh -p DS-PR -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DS-PR
fi

RESULT=`./cegartix-run.sh -p DC-PR -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DC-PR
fi

RESULT=`./cegartix-run.sh -p DC-PR -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DC-PR
fi

RESULT=`./cegartix-run.sh -p SE-PR -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[1,3,5,7]" ];
then
  echo error SE-PR
fi

RESULT=`./cegartix-run.sh -p EE-PR -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[[1,3,5,7]]" ];
then
  echo error EE-PR
fi

# semi
RESULT=`./cegartix-run.sh -p DS-SST -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DS-SST
fi

RESULT=`./cegartix-run.sh -p DS-SST -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DS-SST
fi

RESULT=`./cegartix-run.sh -p DC-SST -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DC-SST
fi

RESULT=`./cegartix-run.sh -p DC-SST -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DC-SST
fi

RESULT=`./cegartix-run.sh -p SE-SST -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[1,3,5,7]" ];
then
  echo error SE-SST
fi

RESULT=`./cegartix-run.sh -p EE-SST -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[[1,3,5,7]]" ];
then
  echo error EE-SST
fi

# stage
RESULT=`./cegartix-run.sh -p DS-STG -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DS-STG
fi

RESULT=`./cegartix-run.sh -p DS-STG -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DS-STG
fi

RESULT=`./cegartix-run.sh -p DC-STG -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DC-STG
fi

RESULT=`./cegartix-run.sh -p DC-STG -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DC-STG
fi

RESULT=`./cegartix-run.sh -p SE-STG -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[1,3,5,7]" ];
then
  echo error SE-STG
fi

RESULT=`./cegartix-run.sh -p EE-STG -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[[1,3,5,7]]" ];
then
  echo error EE-STG
fi

# stable
RESULT=`./cegartix-run.sh -p DS-ST -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DS-ST
fi

RESULT=`./cegartix-run.sh -p DS-ST -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DS-ST
fi

RESULT=`./cegartix-run.sh -p DC-ST -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DC-ST
fi

RESULT=`./cegartix-run.sh -p DC-ST -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DC-ST
fi

RESULT=`./cegartix-run.sh -p SE-ST -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[1,3,5,7]" ];
then
  echo error SE-ST
fi

RESULT=`./cegartix-run.sh -p SE-ST -fo apx -f tests/self-attack.apx 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error SE-ST no stable extension
fi

RESULT=`./cegartix-run.sh -p EE-ST -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[[1,3,5,7]]" ];
then
  echo error EE-ST
fi

# complete
RESULT=`./cegartix-run.sh -p DS-CO -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DS-CO
fi

RESULT=`./cegartix-run.sh -p DS-CO -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DS-CO
fi

RESULT=`./cegartix-run.sh -p DC-CO -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DC-CO
fi

RESULT=`./cegartix-run.sh -p DC-CO -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DC-CO
fi

RESULT=`./cegartix-run.sh -p SE-CO -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[1,3,5,7]" ];
then
  echo error SE-CO
fi

RESULT=`./cegartix-run.sh -p EE-CO -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[[1,3,5,7]]" ];
then
  echo error EE-CO
fi

# grounded
RESULT=`./cegartix-run.sh -p DC-GR -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DC-GR
fi

RESULT=`./cegartix-run.sh -p DC-GR -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DC-GR
fi

RESULT=`./cegartix-run.sh -p SE-GR -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[1,3,5,7]" ];
then
  echo error SE-GR
fi

# ideal
RESULT=`./cegartix-run.sh -p DC-ID -fo apx -f tests/chain.apx -a 1 2>/dev/null`
if [ "$RESULT" != "YES" ];
then
  echo error DC-ID
fi

RESULT=`./cegartix-run.sh -p DC-ID -fo apx -f tests/chain.apx -a 2 2>/dev/null`
if [ "$RESULT" != "NO" ];
then
  echo error DC-ID
fi

RESULT=`./cegartix-run.sh -p SE-ID -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[1,3,5,7]" ];
then
  echo error SE-ID
fi

RESULT=`./cegartix-run.sh -p D3 -fo apx -f tests/chain.apx 2>/dev/null`
if [ "$RESULT" != "[[1,3,5,7]],[[1,3,5,7]],[[1,3,5,7]]" ];
then
  echo error Dung
fi

RESULT=`./cegartix-run.sh -p D3 -fo apx -f tests/grd-stb-pref-diff.apx 2>/dev/null`
if [ "$RESULT" != "[[]],[[b]],[[b],[c]]" ];
then
  echo error Dung
fi


echo "Performing tests from ICCMA'17"

count=0
total=`ls -l tests/iccma2/ExampleInstances_1_2017/apx/*.apx | wc -l`
pstr="[=======================================================================]"

FILES=tests/iccma2/ExampleInstances_1_2017/apx/*.apx
for FILE in $FILES
do

SOLFILE=`basename $FILE .apx`

# echo $FILE

# prf
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.EE-PR | sed 's/a//g' > left.tmp
./cegartix -semantics=pref -mode=enum $FILE 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error pref $FILE
fi

# semi
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.EE-SST | sed 's/a//g' > left.tmp
./cegartix -semantics=semi -mode=enum $FILE 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error semi $FILE
fi

# stage
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.EE-STG | sed 's/a//g' > left.tmp
./cegartix -semantics=stage -mode=enum $FILE 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error stage $FILE
fi

# grd
echo -n "[" > left.tmp
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.SE-GR | sed 's/a//g' | tr -d '\n' >> left.tmp
echo "]" >> left.tmp
./cegartix -semantics=grd -mode=enum $FILE  2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error grounded $FILE
fi

# id
echo -n "[" > left.tmp
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.SE-ID | sed 's/a//g' | tr -d '\n' >> left.tmp
echo "]" >> left.tmp
./cegartix -semantics=ideal -mode=enum $FILE  2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error ideal $FILE
fi

# com
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.EE-CO | sed 's/a//g' > left.tmp
./cegartix -semantics=com -mode=enum $FILE 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error complete $FILE
fi

# stable
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.EE-ST | sed 's/a//g' > left.tmp
./cegartix -semantics=stable -mode=enum $FILE 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error stable $FILE
fi

# dung
echo -n "[[" > left.tmp
cat tests/iccma2/ExampleInstances_1_2017/solutions/$SOLFILE.D3 | wc -m | tr -d '\n' >> left.tmp
echo -n "]]" >> left.tmp
echo -n "[[" > right.tmp
./cegartix -semantics=dung -mode=enum $FILE 2>/dev/null | wc -m | tr -d '\n' >> right.tmp
echo -n "]]" >> right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error dung $FILE
fi


count=$(( $count + 1 ))
  pd=$(( $count * 73 / $total ))
  printf "\r%3d.%1d%% %.${pd}s" $(( $count * 100 / $total )) $(( ($count * 1000 / $total) % 10 )) $pstr

done

echo ""


if [ "$1" == "all" ];
then

echo "Performing tests from ICCMA'15 (this will take about 1-3 minutes)"

count=0
total=`ls -l tests/iccma/*.apx | wc -l`
pstr="[=======================================================================]"

FILES=tests/iccma/*.apx
for FILE in $FILES
do

SOLFILE=`basename $FILE`

# prf
cat tests/iccma/$SOLFILE.EE-PR | sed 's/a//g' > left.tmp
./cegartix -semantics=pref -mode=enum $FILE 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error pref iccma 15 $FILE
fi

# stable
cat tests/iccma/$SOLFILE.EE-ST | sed 's/a//g' > left.tmp
./cegartix -semantics=stable -mode=enum $FILE 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error stable iccma 15 $FILE
fi

count=$(( $count + 1 ))
  pd=$(( $count * 73 / $total ))
  printf "\r%3d.%1d%% %.${pd}s" $(( $count * 100 / $total )) $(( ($count * 1000 / $total) % 10 )) $pstr

done

echo ""

fi






exit










echo "Performing simple tests..."

OUT=`comm <(./cegartix-run.sh -f tests/mutual-attack.apx -p EE-PR -fo apx  2>/dev/null | grep -o "\[[a-z]*\]" | grep -o "[a-z]*" | sort) tests/mutual-attack.apx-solution -3`
if [ "$OUT" != "" ];
then
  echo error 1
fi

OUT=`comm <(./cegartix-run.sh -f tests/chain.apx -p EE-PR -fo apx  2>/dev/null | grep -o "\[[a-z0-9,]*\]" | sed 's/,/ /g' | sed 's/\]\|\[//g' | sort) tests/chain.apx-solution -3`
if [ "$OUT" != "" ];
then
  echo error 2
fi

OUT=`comm <(./cegartix-run.sh -f tests/cred-vs-skept.apx -p EE-PR -fo apx  2>/dev/null | grep -o "\[[a-z0-9,]*\]" | sed 's/,/ /g' | sed 's/\]\|\[//g' | sort) tests/cred-vs-skept.apx-solution -3`
if [ "$OUT" != "" ];
then
  echo error 3
fi

OUT=`comm <(./cegartix-run.sh -f tests/cred-vs-skept.apx -p DS-PR -fo apx -a a 2>/dev/null) tests/cred-vs-skept.apx-solution-skept-a -3`
if [ "$OUT" != "" ];
then
  echo error 41
fi

OUT=`comm <(./cegartix-run.sh -f tests/cred-vs-skept.apx -p DS-PR -fo apx -a b 2>/dev/null) tests/cred-vs-skept.apx-solution-skept-b -3`
if [ "$OUT" != "" ];
then
  echo error 42
fi

OUT=`comm <(./cegartix-run.sh -f tests/cred-vs-skept.apx -p DS-PR -fo apx -a c 2>/dev/null) tests/cred-vs-skept.apx-solution-skept-c -3`
if [ "$OUT" != "" ];
then
  echo error 43
fi

OUT=`comm <(./cegartix-run.sh -f tests/cred-vs-skept.apx -p DS-PR -fo apx -a d 2>/dev/null) tests/cred-vs-skept.apx-solution-skept-d -3`
if [ "$OUT" != "" ];
then
  echo error 44
fi

OUT=`comm <(./cegartix-run.sh -f tests/mutual-attack.apx -p EE-PR -fo apx  2>/dev/null | grep -o "\[[a-z0-9,]*\]" | sed 's/,/ /g' | sed 's/\]\|\[//g' | sort) tests/mutual-attack.apx-solution -3`
if [ "$OUT" != "" ];
then
  echo error 5
fi

OUT=`comm <(./cegartix-run.sh -f tests/self-attack.apx -p EE-PR -fo apx  2>/dev/null | grep -o "\[[a-z0-9,]*\]" | sed 's/,/ /g' | sed 's/\]\|\[//g' | sort) tests/self-attack.apx-solution -3`
if [ "$OUT" != "" ];
then
  echo error 61
fi

OUT=`comm <(./cegartix-run.sh -f tests/self-attack.apx -p SE-PR -fo apx  2>/dev/null | grep -o "[a-z0-9,]*" | sed 's/,/ /g' | sed 's/\]\|\[//g' | sort) tests/self-attack.apx-solution -3`
if [ "$OUT" != "" ];
then
  echo error 62
fi

OUT=`comm <(./cegartix-run.sh -f tests/inst_2_70_3_1 -p EE-PR -fo apx  2>/dev/null | grep -o "\[[a-z0-9,]*\]" | sed 's/,/ /g' | sed 's/\]\|\[//g' | sort) tests/inst_2_70_3_1-solution -3`
if [ "$OUT" != "" ];
then
  echo error 7
fi

echo "Performing iccma'15 tests... (this will take about 1-3 minutes)"

count=0
total=`ls -l tests/iccma/*.apx | wc -l`
pstr="[=======================================================================]"



FILES=tests/iccma/*.apx
for FILE in $FILES
do
CHECK=`cat $FILE.EE-ST`
if [[ "$CHECK" == "[]" ]]; 
then
cat $FILE.EE-SST | sed 's/a//g' > left.tmp
else
cat $FILE.EE-ST | sed 's/a//g' > left.tmp
fi
./cegartix-run.sh -f $FILE -p EE-SST -fo apx 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error semi-stable $FILE
fi

# ./cegartix-run.sh -f $FILE -p EE-STG -fo apx 2>/dev/null | sed 's/a//g' > right.tmp
# if [ "$OUT" != "set([])" ];
# then
#   echo error stage $FILE
# fi

cat $FILE.EE-PR | sed 's/a//g' > left.tmp
./cegartix-run.sh -f $FILE -p EE-PR -fo apx 2>/dev/null | sed 's/a//g' > right.tmp
OUT=`python compare-results.py left.tmp right.tmp`
if [ "$OUT" != "set([])" ];
then
  echo error preferred $FILE
fi

count=$(( $count + 1 ))
  pd=$(( $count * 73 / $total ))
  printf "\r%3d.%1d%% %.${pd}s" $(( $count * 100 / $total )) $(( ($count * 1000 / $total) % 10 )) $pstr

done

echo ""